Draft BSpline/sv: Difference between revisions

From FreeCAD Documentation
(Created page with "{{GuiCommand/sv|Name=Draft BSpline|Workbenches=Draft, Arch|MenuLocation=Draft -> BSpline|Shortcut=B S|SeeAlso=Draft Wire}}")
(Updating to match new version of source page)
Line 2: Line 2:


==Description==
==Description==
The BSpline tool creates a [http://en.wikipedia.org/wiki/B-spline B-Spline curve] from several points in the current [[Draft Workingplane|work plane]]. It takes the [[Draft Linestyle|linewidth and color]] previously set on the Tasks tab. The BSpline tool behaves exactly like the [[Draft Wire]] tool.
The BSpline tool creates a [http://en.wikipedia.org/wiki/B-spline B-Spline curve] from several points in the current [[Draft SelectPlane|work plane]]. It takes the [[Draft Linestyle|linewidth and color]] previously set on the Tasks tab. The BSpline tool behaves exactly like the [[Draft Wire]] tool.


[[Image:Draft_bspline_example.jpg|400px]]
[[Image:Draft_bspline_example.jpg|400px]]
Line 25: Line 25:
* Press {{KEY|I}} or the {{KEY|'''Filled'''}} button to have the spline to appear as a face after it has been closed. This simply sets the View->Property of the Wire to "Flat lines" or "Wireframe", so it can easily be changed later.
* Press {{KEY|I}} or the {{KEY|'''Filled'''}} button to have the spline to appear as a face after it has been closed. This simply sets the View->Property of the Wire to "Flat lines" or "Wireframe", so it can easily be changed later.
* Press {{KEY|ESC}} or the {{KEY|'''Cancel'''}} button to abort the current BSpline command.
* Press {{KEY|ESC}} or the {{KEY|'''Cancel'''}} button to abort the current BSpline command.
* BSplines, when in "Flat Lines" display mode, can display a hatch pattern, by setting their "Pattern" property below.


==Properties==
==Properties==
* {{PropertyData|Closed}}: Specifies if the spline is closed or not
* {{PropertyData|Closed}}: Specifies if the spline is closed or not
* {{PropertyView|End Arrow}}: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line
* {{PropertyView|End Arrow}}: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line
* {{PropertyView|Pattern}}: Specifies a hatch pattern to fill the wire with
* {{PropertyView|Pattern Size}}: Specifies the size of the hatch pattern


==Scripting==
==Scripting==
Line 34: Line 37:


<syntaxhighlight>
<syntaxhighlight>
'''makeBSpline (pointslist,[closed],[placement])'''
makeBSpline (pointslist,[closed],[placement])
</syntaxhighlight>
</syntaxhighlight>
* Creates a B-Spline object from the given list of vectors.
* Creates a B-Spline object from the given list of vectors.

Revision as of 17:21, 31 May 2014

Draft BSpline

Menyplacering
Draft -> BSpline
Arbetsbänkar
Draft, Arch
Standard genväg
B S
Introducerad i version
-
Se även
Draft Wire

Description

The BSpline tool creates a B-Spline curve from several points in the current work plane. It takes the linewidth and color previously set on the Tasks tab. The BSpline tool behaves exactly like the Draft Wire tool.

How to use

  1. Press the Draft BSpline button, or press B then S keys
  2. Click a first point on the 3D view, or type a coordinate
  3. Click additional point on the 3D view, or type a coordinate
  4. Press F or C, or double-click the last point, or click on the first point to finish or close the spline. If the spline is closed, it will also be a face, even if it appears as wireframe.

Options

  • Press F or the Finish button to finish the spline, leaving it open
  • Press C or the Close button or click on the first point to finish the spline, but making it closed by adding a last segment between the last point and the first one.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press ENTER between each X, Y and Z component.
  • Press R or click the checkbox to check/uncheck the Relative button. If relative mode is on, the coordinates of the next point are relative to the last one. If not, they are absolute, taken from the (0,0,0) origin point.
  • Press T or click the checkbox to check/uncheck the Continue button. If continue mode is on, the BSpline tool will restart after you finish or close it, allowing you to draw another one without pressing the BSpline button again.
  • Press CTRL while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press SHIFT while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press W or press the Wipe button to remove the existing segments and start the spline from the last point.
  • Press CTRL+Z or press the Undo button to undo the last point.
  • Press I or the Filled button to have the spline to appear as a face after it has been closed. This simply sets the View->Property of the Wire to "Flat lines" or "Wireframe", so it can easily be changed later.
  • Press ESC or the Cancel button to abort the current BSpline command.
  • BSplines, when in "Flat Lines" display mode, can display a hatch pattern, by setting their "Pattern" property below.

Properties

  • DataClosed: Specifies if the spline is closed or not
  • VyEnd Arrow: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line
  • VyPattern: Specifies a hatch pattern to fill the wire with
  • VyPattern Size: Specifies the size of the hatch pattern

Scripting

The BSpline tool can by used in macros and from the python console by using the following function:

 makeBSpline (pointslist,[closed],[placement])
  • Creates a B-Spline object from the given list of vectors.
  • If closed is True or first and last points are identical, the wire is closed.
  • If face is true (and the bspline is closed), the bspline will appear filled.
  • Instead of a list of points, you can also pass a Part Wire.
  • Returns the newly created object.

Example:

 import FreeCAD,Draft
 p1 = FreeCAD.Vector(0,0,0)
 p2 = FreeCAD.Vector(1,1,0)
 p3 = FreeCAD.Vector(2,0,0)
 Draft.makeBSpline([p1,p2,p3],closed=True)